package edu.uog.exercise.unitconverter.todolist;


import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import java.util.ArrayList;
import java.util.List;



public class DatabaseHelper extends SQLiteOpenHelper {

    private static final String DATABASE_NAME ="myLogbookDatabase.db";
    private static final String TABLE_TASK ="tblTask";

    public static final String _ID = "id";
    public static final String NAME = "name";
    public static final String TASK = "task";
    public static final String STATUS = "status";

    private SQLiteDatabase database;

    private static final String CREATE_PERSON_TABLE =String.format(
            "CREATE TABLE IF NOT EXISTS %s (" +
                    " %s INTEGER PRIMARY KEY AUTOINCREMENT," +
                    " %s TEXT," +
                    " %s TEXT," +
                    " %s TEXT)"
            , TABLE_TASK, _ID, NAME, TASK, STATUS);


    public DatabaseHelper(Context context){
        super(context, DATABASE_NAME, null, 1);
        database =getWritableDatabase();
        if(database !=null) database.execSQL( "PRAGMA encoding ='UTF-8'" );
    }

    @Override
    public void onCreate(SQLiteDatabase sqLiteDatabase) {
        sqLiteDatabase.execSQL(CREATE_PERSON_TABLE);

    }

    @Override
    public void onUpgrade(SQLiteDatabase sqLiteDatabase, int i, int i1) {

    }

    public long save(String name, String task, String status){
        long result =0;
        ContentValues rowValues =new ContentValues();
        rowValues.put(NAME, name);
        rowValues.put(TASK, task);
        rowValues.put(STATUS, status);
        result =database.insertOrThrow(TABLE_TASK, null, rowValues);
        return result;
    }

    public List search( ) throws Exception{
        Cursor cursor = null;
        String query ="SELECT * FROM " + TABLE_TASK;

        List<ToDoItem> results =new ArrayList<>();
        cursor = database.rawQuery( query, null );
        cursor.moveToFirst( );
        while( !cursor.isAfterLast() ){
            int id =cursor.getInt(0);
            String name =cursor.getString(1);
            String task =cursor.getString(2);
            String status =cursor.getString(3);
            cursor.moveToNext( );
            ToDoItem toDoItem =new ToDoItem(id, name, task, status);
            results.add(toDoItem);
        }
        cursor.close();
        return results;
    }

    public long delete(int id) {
        long result =0;
        String where = "id=?";
        String values[] = { String.valueOf(id) };
        result =database.delete(TABLE_TASK, where, values);
        return result;
    }


    public long update(int id, String name, String task, String status) {
        long result =0;
        ContentValues rowValues =new ContentValues();
        rowValues.put(NAME, name);
        rowValues.put(TASK, task);
        rowValues.put(STATUS, status);
        String where = "id=?";
        String values[] = {id +""};
        result =database.update(TABLE_TASK, rowValues, where, values);
        return result;
    }
}
